/*gestore della risorsa va in esecuzione prima di tutti.
Esso esegue un create_server_endpoint su una porta nota anche a seccord
Aspetta il collegamento da Seccord, dopodiche' la risorsa e' attiva
Si usa la porta ricevi con la select in modo da poter ricevere sia dal seccord che dal cliente. Infatti si puo' ipotizzare che il gestore debba ricevere da seccord l'endpoint del cliente da servire per confrontarlo con quello del cliente che si collega al gestore.(PROTOCOLLO DI AUTORIZZAZIONE)*/

#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netdb.h>
#include <signal.h>
/*#include <unistd.h>*/
#include <sys/ipc.h>
#include <sys/stat.h>
#include <fcntl.h>
#define LEN 50
typedef struct {u_short len; char name[6];} Request;
typedef struct {u_short sin_port;u_long sin_addr;} Token_format; /*size=6*/
typedef struct {u_short stato;u_short numelem;u_long tkid;} Dimtoken_format; /*size=4*/

int inizio,sdsec,sdcli,ricevutosec,ricevutocli,autorizzato=0,eseguito=0;
Request ricsec,riccli;

int create_server_endpoint(int port)
{
struct sockaddr_in addr;
static int h;

h=socket(AF_INET,SOCK_STREAM,0);
memset((void*)&addr,0,sizeof(addr));
addr.sin_family=AF_INET;
addr.sin_port=htons(port);
addr.sin_addr.s_addr=INADDR_ANY;
bind(h,(struct sockaddr*)&addr,sizeof(addr));
listen(h,5);
return h;
}

int send_response(int h, Request *risp)
{ Request rispo;
  int lung,w_bytes;
  static int n;
  rispo=*risp;
  lung=sizeof(rispo);
  printf("\nInizio a spedire (rispo.name=%s) e (rispo.len=%d) ",rispo.name,rispo.len); 

for(w_bytes=0;w_bytes<lung;w_bytes+=n)
  {
   n=send(h,((char*)&rispo)+w_bytes,lung-w_bytes,0);
   printf("\nHo spedito %d byte al cliente\n",n);
  }
 return(n);
}

int recv_cliep (int h,Token_format *req) 
{static int r_bytes,n;
 int len=sizeof(*req);

 for(r_bytes=0;r_bytes<len;r_bytes+=n)
 { n=recv(h,((char*)req)+r_bytes,len-r_bytes,0);
   if (n<=0) {printf("\nErrore nella receive");
              return n;}
  }
/*Decodifico len*/
req->sin_port=ntohl(req->sin_port);
req->sin_addr=ntohl(req->sin_addr);
printf("\nHo ricevuto 1 campo lia:(%d) ",req->sin_addr);
printf("\nHo ricevuto 2 campo :(%d) ",req->sin_port);
return r_bytes;
}

int recv_string (int h,char *req) 
{static int r_bytes,n;
 int len=4;
 
 for(r_bytes=0;r_bytes<len;r_bytes+=n)
 { n=recv(h,((char*)req)+r_bytes,len-r_bytes,0);
   if (n<=0) return n;
  }
printf("\nHo ricevuto  :(%s) ",req);
return r_bytes;
}

int send_string(int h, char *risp)
{ 
  int lung,w_bytes;
  static int n;
  lung=sizeof(*risp);
 
for(w_bytes=0;w_bytes<lung;w_bytes+=n)
  {
   n=send(h,((char*)risp)+w_bytes,lung-w_bytes,0);
   printf("\nHo rispedito %s  al cliente\n",risp);
  }
 return(n);
}

void azione_risorsa(Token_format *risp)
{printf("\nSto eseguendo la richiesta del cliente!\n");
 sleep(2);
 eseguito=1;
}

int send_cliep(int h, Token_format *risp)
{ Token_format rispo;
  int lung,w_bytes;
  static int n;

   rispo=*risp;
   lung=sizeof(rispo);
   printf("\nSpedisco al al cliente la risposta (rispo.sin_addr=%d) e (rispo.len=%d)\n",rispo.sin_addr,rispo.sin_port); 

for(w_bytes=0;w_bytes<lung;w_bytes+=n)
   n=send(h,((char*)&rispo)+w_bytes,lung-w_bytes,0);
 
 return(n);
}

int handle(int h) 
{ Token_format req;
  char *car;
  struct sockaddr_in peeraddr_in;
  int addrlen,fine;
  static int ret;

  memset((char*)&peeraddr_in,0,sizeof(struct sockaddr_in));
  printf("\nsono in handle");
  if (h==sdsec)
                {printf("\nVado a ricevere dal seccord l'ENDPOINT del cliente!");
                 if(recv_cliep(h,&req)<=0) return 0;
                 ricsec.len=req.sin_port;
 		 }                
 if(h==sdcli)
               { getsockname(h,(struct sockaddr*)&peeraddr_in,&addrlen);
                 printf("\nVado a ricevere dal cliente i suoi DATI");
	
                   if(recv_cliep(h,&req)<=0) return 0;
                   azione_risorsa(&req);
                   ret=send_cliep(h,&req);
		   if(ret>0) {sdcli=-1;
 			      ret=0;
                                      }	
		   else {printf("problemi nello spedire la risposta\n");
			 ret=1;
 			}	
                    /*comunico a seccord la fine del servizio*/
                    if (ret==0) {req.sin_port=0;req.sin_addr=0;}
                    else {req.sin_port=1;req.sin_addr=1;}
                    fine=send_cliep(sdsec,&req);
                    printf("\nHo spedito al seccord l'esito dell'operazione\n");
                    return ret;
		
		}           

}



int main(argc,argv)
int argc;
char **argv;
{ 
 int ricevi,listener,maxhp1,pidn,portar,nextsd;
 fd_set read_hs,temp_hs; 
 char nexthost[10],thishost[10];
  
 printf("\nDigita il nome della macchina di esecuzione:");
 scanf("%s",thishost);

 printf("\nDigita il numero di porta sulla quale gestire le comunicazioni:");
 scanf("%d",&portar);
   
 printf("\nDigita il nome dell'host dove risiede seccord:"); 
 scanf("%s",nexthost);
 
 
if((pidn=fork())<0) exit(1);
if(pidn>0) exit(0);

else
{
setsid();
/*chdir("/"); */
umask(0);
/*  for(i=0;i<_NFILE;i++) close(i);*/

 listener=create_server_endpoint(portar);  
 maxhp1=listener+1;
 FD_ZERO(&read_hs);
 FD_ZERO(&temp_hs);
 FD_SET(listener,&read_hs);
 FD_SET(listener,&temp_hs);
 temp_hs=read_hs;
 close(stdin);
 close(stderr); 
 signal(SIGCHLD,SIG_IGN);
 inizio=1;sdsec=sdcli=-1;
 for(;;)
    { int h;
     /*Timeout nullo ed attesa infinita*/
     printf("\nsono prima della select");
     select(maxhp1,&temp_hs,0,0,(struct timeval*)0);

     /*Verifica delle richieste presenti sulle connessioni*/
     for(h=listener+1;h<maxhp1;h++)
     { if(FD_ISSET(h,&temp_hs))
         if(handle(h)==0)
         /*Chiusura della connessione da parte del cliente*/  
         {FD_CLR(h,&read_hs);close(h);}
     }   /*richieste di nuove connessioni */
     
     if((FD_ISSET(listener,&temp_hs))&&(sdsec==-1 || sdcli==-1)) 
    	/*Non mi interessa indirizzo di chi si collega a me */
 	   {    printf("\nsono prima dell'accept");
                h=accept(listener,0,0);
 		FD_SET(h,&read_hs);
 		if(maxhp1<=h) maxhp1=h + 1;
                if(inizio) {printf("\nRicevuto collegamento da seccord");
                            inizio=0;
                             sdsec=h;}
                else {printf("\nRicevuto un collegamento da un cliente!");
                      sdcli=h;}

           }
 	temp_hs=read_hs;
        }
     } 
 
}
