
/* Programma coordinatore al quale fanno capo due processi figli che hanno il compito rispettivamente di gestire la circolazione del token e le richieste di inserimento da parte di nuovi clienti. Seguono entrambi la struttura di server concorrente sequenziale che utilizza gli asincronismi della primitiva select per simulare il parallelismo senza generare ulteriori figli.

Va mandato in esecuzione solo dopo aver attivato il programma "Seccord" e il "Gestore" della risorsa.*/ 



#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netdb.h>
#include <signal.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/stat.h>
#include <fcntl.h>
#define LEN 50
typedef struct {u_short len; char name[6];} Request;
typedef struct {u_short sin_port;u_long sin_addr;} Token_format; /*size=6*/
typedef struct {u_short stato;u_short numelem;u_long tkid;} Dimtoken_format; /*size=4*/
struct elemento {u_short sin_port; u_long sin_addr; struct elemento *next;} list_entry;
struct elemento *piniz,*piniz1,*plav,*precplav,*elem,*scorri;


typedef struct hostent Hostent;
Token_format arraytoken[LEN],arraytoken_new[LEN],primotoken[LEN],insertoken[2];
typedef int HANDLE;
long dimtoken,idtoken=0,dimtoken1; /*dimensione e identificatore del token*/
 u_long indirizzo;u_short portoken;
Request seccord,myhost,nextnodo;
int statotoken,ipcsd,ipcris,ipcex,ipccr,rcvtk,in_new_token,ok_token,azzera=0,dimring,precusc=0,crash=0,inrecovery=0,sveglia=0;
u_short mylen;
/*FUNZIONE*/



void stampa_ring()
{ int i;
  printf("\n La struttura attuale del ring e'...\n");
  scorri=piniz;i=1;
   while ((scorri->next)!=piniz)
   {  printf("\n%d) elemento :nome= (lia%d)  porta=(%d)",i,scorri->sin_addr,scorri->sin_port);
    if ((scorri->next)!=piniz) scorri=scorri->next;
    i++;
   }

     printf("\n%d) elemento :nome= (lia%d)  porta=(%d)\n",i,scorri->sin_addr,scorri->sin_port);
  
  
 
}

void inizializza_ring(Token_format *cord, Token_format *sec)
{Token_format cordtk,secco;
   
  cordtk=*cord;secco=*sec;

 elem=(struct elemento *)malloc(sizeof(list_entry));
 elem->sin_port=cordtk.sin_port;
 elem->sin_addr=cordtk.sin_addr;
 elem->next=NULL;
 piniz=elem; /*puntatore all'inizio della coda*/
 elem=(struct elemento *)malloc(sizeof(list_entry)); elem->sin_port=secco.sin_port;
 elem->sin_addr=secco.sin_addr;
 elem->next=piniz; /*secco punta a cordtk*/
 piniz->next=elem; /*cordtk punta a secco*/
 piniz1=elem;
 dimring=2;
}



HANDLE create_server_endpoint(int port)
{
struct sockaddr_in addr;
HANDLE h;

h=socket(AF_INET,SOCK_STREAM,0);
memset((void*)&addr,0,sizeof(addr));
addr.sin_family=AF_INET;
addr.sin_port=htons(port);
addr.sin_addr.s_addr=INADDR_ANY;
bind(h,(struct sockaddr*)&addr,sizeof(addr));
listen(h,5);
return h;
}

HANDLE create_nexthost_endpoint(int port, char *nomehp)
{struct sockaddr_in addr;
 struct hostent *hp;
HANDLE h;
hp=(Hostent *)malloc(sizeof(Hostent));
h=socket(AF_INET,SOCK_STREAM,0);
if(h==-1)
{  fprintf(stderr,"Impossibile aprire socket \n");
   fflush(stdout); 
   return 0;
}
hp=gethostbyname(nomehp);
if(hp==NULL)
   {fprintf(stderr,"%s non trovato in /etc/hosts\n",nomehp);
    fflush(stdout); 
    return 0;
   }

memset((void*)&addr,0,sizeof(addr));
addr.sin_family=AF_INET;
addr.sin_port=htons(port);
addr.sin_addr.s_addr=((struct in_addr*)(hp->h_addr))->s_addr;;
indirizzo=addr.sin_addr.s_addr;
if(connect(h,(struct sockaddr*)&addr,sizeof(struct sockaddr_in))==-1)
{  fprintf(stderr,"Impossibile connettersi \n");
   fflush(stdout); 
   return 0;
}
 printf("\nMi sono collegato con la porta=%u",addr.sin_port);
 return h;
}


/* FUNZIONE che riceve la richiesta*/

int recv_request (HANDLE h,Request *req) 
{
int r_bytes,n;

int len=sizeof(*req);
for(r_bytes=0;r_bytes<len;r_bytes+=n)
{ n=recv(h,((char*)req)+r_bytes,len-r_bytes,0);
if (n<=0) return n;
}
/*Decodifico len*/
req->len=ntohl(req->len);
printf("\n Ho ricevuto dal nuovo nodo il suo endpoint (%s) (%d)",req->name,req->len);

return r_bytes;
}



/*FUNZIONE di invio risposta al cliente*/

int send_response(HANDLE h, Request *risp)
{ Request rispo;
  int lung,w_bytes,n;
  rispo=*risp;
  lung=sizeof(rispo);

for(w_bytes=0;w_bytes<lung;w_bytes+=n)
   n=send(h,((char*)&rispo)+w_bytes,lung-w_bytes,0);
 shutdown(h,1);
 return(n);
}


/*FUNZIONE che attua l'azione*/
Request *inserisci_endpoint(Request *req)	
{ static Request target;
  Request appreq;  
  int trovato,fatto=0;
  char nome[5];

  appreq=*req;
  elem=(struct elemento *)malloc(sizeof(list_entry));
  elem->sin_port=appreq.len;
  elem->sin_addr=converti((appreq.name+3),2);
  printf(" lo aggiungo al ring.");

 if (piniz==(piniz1->next)) /*ci sono solo cordtok e seccord*/ 
 {     printf("Il Ring e' formato dai soli coordinatori\n");
       elem->next=piniz;
       piniz1->next=elem;
       target=myhost; /*myhost=cordtok se ci sono solo i due cord lo inserisco dietro a cordtk*/ 
       printf("connetto il nuovo nodo (%s) (%d) a Cordtok %s %d\n",req->name,req->len,target.name,target.len);fatto=1;
      
 } 
 else
 { precplav=piniz;
  plav=piniz1;/*scandisco a partire da seccord,  visto che non inseriro' mai un nodo tra i due coord*/
   trovato=0;
   while ((plav->next!=piniz)&&(!trovato))
   {    precplav=precplav->next;plav=plav->next;
       if ((plav->sin_addr)>=(elem->sin_addr))
       {precplav->next=elem;
        elem->next=plav;
        if(plav->sin_addr<=9) sprintf(target.name,"lia0%d",plav->sin_addr);
	else sprintf(target.name,"lia%d",plav->sin_addr);
        target.len=plav->sin_port;
        trovato=1;
       }
   }
   if (!trovato) {plav->next=elem;
                  elem->next=piniz;
                  target=myhost;
                 }
   } 
   dimring++;
   if (fatto==0) printf("Il nodo a cui collegarsi e' %s %d\n",target.name,target.len);
   return(&target);
}


liaxx(int ind,char buf[5])
 {
if(ind<=9) sprintf(buf,"lia0%d",ind);
	else sprintf(buf,"lia%d",ind);
 }	

Token_format togliprec_endpoint(char *pren)	
  {
 int trovato,ind,port;
 static Token_format tkret;
 struct elemento *app;

 ind=converti((pren+3),2);
 port=converti((pren+5),5);
 app=NULL;
 tkret.sin_addr=0;
 tkret.sin_port=0;
 app=precplav=piniz;
 plav=piniz1;
 trovato=0;
 printf("\nDevo cercare il nodo precedente a lia%d %d\n",ind,port);
 while ((plav!=piniz)&&(!trovato))
   {    precplav=precplav->next;
        plav=plav->next;
       if (((plav->sin_addr)==(ind))&&(plav->sin_port==port))
       {app->next=plav;
        printf("\nElimino dal ring:lia%d porta=%d\n",precplav->sin_addr,precplav->sin_port);
        free(precplav);
	printf(" e restituisco lia%d %d\n",app->sin_addr,app->sin_port);
	tkret.sin_addr=app->sin_addr;
	tkret.sin_port=app->sin_port;
        trovato=1;
       }
	app=app->next;
   }
if (!trovato) printf("\nIl nodo non fa parte del ring");   
return(tkret);
}

togli_endpoint(int nome,int porta)   
{int trovato;

 printf("\nL'elemento lia%d porta=%d esce dal ring",nome,porta);
 if (piniz==(piniz1->next)) /*ci sono solo cordtok e seccord*/ 
      printf("\nRing formato solo dai cordinatori");  
  else
 { precplav=piniz;
   plav=piniz1;/*scandisco a partire da seccord,  visto che non inseriro' mai un nodo tra i due coord*/
   trovato=0;
   while ((plav->next!=piniz)&&(!trovato))
   {    precplav=precplav->next;
        plav=plav->next;
       if (((plav->sin_addr)>=(nome))&&(plav->sin_port==porta))
       {precplav->next=plav->next;
        printf("\nElimino dal ring:lia%d porta=%d\n",plav->sin_addr,plav->sin_port);
        free(plav);
        trovato=1;
       }
   }
   if (!trovato) printf("\nIl nodo non fa parte del ring");  
 }
}


/*FUNZIONE che attua l'azione*/

Request *azione(Request *req)
{  static Request *nodo_target;
   char *buf;
   
   buf=(char *)malloc(20);
   nodo_target=(Request *)malloc(sizeof(Request));
   nodo_target=inserisci_endpoint(req);
   sprintf(buf,"%s%d%s%d",nodo_target->name,nodo_target->len,req->name,req->len);
   printf("\nScrivo nell'IPC\n");
   if(write(ipcsd,buf,20)<0)
	{perror("Write");}       
   /*vado a utilizzare la ipc per comunicare al secondo figlio i dati del nuovo arrivato che saranno messi nel token che verra' generato*/

   return(nodo_target);
}
 
/*FUNZIONE che riceve la richiesta, attua l'azione e manda la risposta*/

aggiorna_ring()		
 {
char pren[10],lia[5];
Token_format tkret;
int ind,port,nread;

while((nread=read(ipcex,pren,10))>0)
	{
   ind=converti((pren+3),2);
   port=converti((pren+5),5);
   printf("\nSono in Aggiorna ring\ntolgo dal mio elenco lia%d porta=%d",ind,port);
   togli_endpoint(ind,port);
   stampa_ring();
 	}

if((nread=read(ipccr,pren,10))>0)
	{
   tkret=togliprec_endpoint(pren);
   liaxx(tkret.sin_addr,lia);
   sprintf(pren,"%s%d",lia,tkret.sin_port);
   printf("%s deve ricollegarsi\n",pren);
   if(write(ipccr,pren,10)<0) {perror("Write");}
   stampa_ring();
	}
  }

int handle(HANDLE h) 
{
Request req,*risp;
int nread;

stampa_ring();
if(recv_request(h,&req)<=0) return 0;
shutdown(h,0);
/*Vuol dire che cliente e' disconnesso */
 
risp=(Request *)malloc(sizeof(Request));

risp=azione(&req);   
printf("\nRestituisco l'endpoint per il nuovo collegamento: %s %d\n",risp->name,risp->len);
return send_response(h,risp);
}
 

int send_token(HANDLE h, Token_format *tkout)
{ Dimtoken_format dimout;
  int lung,w_bytes,n;

  dimout.stato=statotoken;
  dimout.numelem=dimtoken;
  dimout.tkid=idtoken+dimtoken-2;
  lung=sizeof(dimout);
  if(ok_token){dimout.stato=statotoken=0;}
  printf("\nSpedisco la dimensione del %d token che vale %d e stato %d",dimout.tkid,dimtoken,dimout.stato);
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(h,((char*)&dimout)+w_bytes,lung-w_bytes,0);
  if(n!=lung) { printf("\nProblemi per spedire la dimensione del token -> Recovery");
                return(-1);
              }
  else
  {  
    lung=sizeof(*tkout)*dimtoken;
    printf("\nSpedisco il %d Token",dimout.tkid); 
    for(w_bytes=0;w_bytes<lung;w_bytes+=n)
        n=send(h,((char*)tkout)+w_bytes,lung-w_bytes,0); 
    if(n!=lung) { printf("\nProblemi per spedire il token -> Recovery");
                  return(-1);
                }
    else return(n);
  }
}

void gestsegn(int signo)
 {
/*al momento non serve a nulla ma potrebbe essere usato come aggiorna_ring*/
 }
 
/*Questa funzione dovra' creare la lista delle richieste pendenti partendo dal contenuto del token arrivato*/

int converti(char *buf,int step)
{int i;char *ris;
  ris=(char *)malloc(step);
  for(i=0;i<step;i++) ris[i]=buf[i];
  return (atoi(ris));
}



  Token_format *azione_token(Token_format *tkin)
{  int i,nread,ret;
   char buf[20];
     
if(statotoken!=2) /*se =2 significa che c'e' una richiesta di uscita dal ring => non e' possibile accettare inserimenti*/
if (nread=read(ipcsd,buf,20)!=20) {}  
else { /*c'e' bisogno del protocollo di inserimento*/
	statotoken=1;
       in_new_token=0; 
       printf("\n Dati letti dall'IPC");
       printf("\nIl ring deve accogliere un nuovo nodo");
       arraytoken[0].sin_addr=converti((buf+3),2);/*endpoint dell'host che cambia l'istradamento*/
       arraytoken[0].sin_port=converti((buf+5),5);
       arraytoken[1].sin_addr=converti((buf+13),2);/*endpoint dell'host che riceve da due rcvtk*/
       arraytoken[1].sin_port=converti((buf+15),5);
       azzera=0;
     }

if((nextnodo.name!=0)&&(nextnodo.len!=0))
if  (arraytoken[0].sin_addr==atol(nextnodo.name+3)) 
  if(arraytoken[0].sin_port==nextnodo.len)
     { printf("\ndevo cambiare l'istradamento\n",myhost.name);  
       insertoken[0].sin_port=arraytoken[0].sin_port;
       insertoken[0].sin_addr=arraytoken[0].sin_addr;
       insertoken[1].sin_port=arraytoken[1].sin_port;
       insertoken[1].sin_addr=arraytoken[1].sin_addr;          
     }
/*
Il protocollo non prevede questa possibilita'
*/      

if(arraytoken[0].sin_addr==atol(myhost.name+3))
   if  (arraytoken[0].sin_port==myhost.len)
     { /*printf("\n Devo ricevere da una nuova connessione\n ",myhost.name);  */
       insertoken[0].sin_port=arraytoken[0].sin_port;
       insertoken[0].sin_addr=arraytoken[0].sin_addr;
       insertoken[1].sin_port=arraytoken[1].sin_port;
       insertoken[1].sin_addr=arraytoken[1].sin_addr;
       sveglia=2;
      
       in_new_token=dimtoken;
/*lo useremo per il confronto con il primo token che arrivera' da rcvtk1 */
       for(ret=0;ret<dimtoken;ret++)
	   { primotoken[ret].sin_port=arraytoken[ret].sin_port;
	     primotoken[ret].sin_addr=arraytoken[ret].sin_addr;
	   }
     }
 if((azzera)&&(statotoken!=2))
          {
/*inserimento finito*/
	arraytoken[0].sin_addr=0;
     	arraytoken[0].sin_port=0;
   	arraytoken[1].sin_addr=0;
    	arraytoken[1].sin_port=0;
	  }
 azzera=1;
 if(statotoken==2)   /*nodo precedente esce*/
	{	if(precusc==1) 
			{
			precusc=0;
			arraytoken[0].sin_port=0;
			arraytoken[0].sin_addr=0;
			arraytoken[1].sin_port=0;
			arraytoken[1].sin_addr=0;
			statotoken=0;
			}
		else	
		   {
		  printf("Esce %d - e interessa %d lia%d\n",arraytoken[0].sin_port,arraytoken[1].sin_port,arraytoken[1].sin_addr);		
		  if((mylen==arraytoken[1].sin_port)&&(atol(myhost.name+3)==arraytoken[1].sin_addr))
			{
			printf("Il nodo precedente vuole uscire dal ring\n");	
			precusc=1;
			}
		   }
	 }
   printf("\n\nIl contenuto del token e'..\n");
  for(i=0;i<dimtoken;i++)
    printf("\n(%d)Elemento porta=(%d) indirizzo=(%d) ",i,arraytoken[i].sin_addr,arraytoken[i].sin_port);        
printf("\n");
return(tkin);

}
 
 
int recv_dimtoken(HANDLE h,Dimtoken_format *req) 
{
int r_bytes,n;
int len=sizeof(*req);
 
for(r_bytes=0;r_bytes<len;r_bytes+=n)
{ n=recv(h,((char*)req)+r_bytes,len-r_bytes,0);
if (n<=0) return n;
}

dimtoken=ntohl(req->numelem);
if(req->stato!=3)
idtoken=idtoken+dimtoken-2;
return r_bytes;
}


/* FUNZIONE che riceve il token*/
int recv_token(HANDLE h,Token_format *tkin) 
{
int r_bytes,n,numelem,i;
int len=sizeof(*tkin)*dimtoken;
      
     for(r_bytes=0;r_bytes<len;r_bytes+=n)
      { n=recv(h,((char*)tkin)+r_bytes,len-r_bytes,0);
        if (n<=0) return n;
      }

           
  
return (r_bytes);
}


int genera_token(HANDLE verso)
{ 
  Token_format tok[2];
  Dimtoken_format dimtok; 
  int lung,w_bytes,n;
  
  /*prima si manda il pacchetto con la dimensione*/
  dimtok.stato=0;
  dimtok.numelem=2;/*il token inizialmente e' vuoto trasporta solo se stesso*/
  dimtok.tkid=0;
  lung=sizeof(dimtok); /*4 byte*/
  printf("\nspedisco la dimensione del token ");
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(verso,((char*)&dimtok)+w_bytes,lung-w_bytes,0);
  if (n!=lung) {printf("\nProblemi a spedire la dim del token ->Recovery");return(-1);}               /*e dopo si manda il token vero e proprio*/
  tok[0].sin_port=0;
  tok[0].sin_addr=0;
  tok[1].sin_port=0;
  tok[1].sin_addr=0;
  lung=sizeof(tok);
  printf("\nspedisco il Token generato");
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(verso,((char*)&tok)+w_bytes,lung-w_bytes,0);
  if (n!=lung) {printf("\nProblemi a spedire il  token ->Recovery");return(-1);}

  return (n);
}


 int handle_new_tok(HANDLE h, HANDLE nexth)
{ Token_format *tkin,*tkout;/*puntatori al token da ricevere e spedire*/
  int ret=0,i;
 
  
  tkin=(Token_format *)malloc(sizeof(Token_format));
  tkin=arraytoken_new;
  if((ret=recv_token(h,tkin))<=0) {printf("\nhandle new tok ritorna %d",ret);
				   ret=-1;
                                   return ret;}
  printf("\nHo ricevuto il token dalla nuova connessione");
  if (in_new_token!=dimtoken1)
     {printf("\nI due token hanno dimensioni diverse! %d  %d",in_new_token,dimtoken1);
      ret=-1;
     }
  else
  for (i=0;i<dimtoken1;i++)
   if ((primotoken[i].sin_port != arraytoken_new[i].sin_port)||(primotoken[i].sin_addr != arraytoken_new[i].sin_addr))   
         { printf("\ni due token sono diversi nella posizione %d:\n %d vs %d",i,primotoken[i].sin_port,arraytoken_new[i].sin_port);
           ret=-2;
         }
    if ((ret!=-1)&&(ret!=-2)) {  
     			        statotoken=0;}
  
   return ret; 
}

Token_format *ripristina_ring(int ind,int port)		
  {
  static Token_format tkrec[2];
  int i,nread=0;
  char indir[10],lia[5];

/*eventuali controlli preliminari per verificare l'effettiva condizione del nodo caduto ed eventualmente decidere di fargli ritentare la connessione*/

  tkrec[0].sin_addr=ind;
  tkrec[0].sin_port=port; 
  printf("\nE' necessario sostituire il nodo caduto prima di lia%d %d\n",ind,port);
  liaxx(ind,lia);
  sprintf(indir,"%s%d",lia,port);
  printf("E' uscito il nodo prima di %s\n",indir);
  if(write(ipccr,indir,10)<0) {perror("Write");}
  kill(0,SIGUSR1);	/*avverto l'altro figlio di aggiornare il ring*/
  sleep(4);
  nread=read(ipccr,indir,10); 
  tkrec[1].sin_addr=converti((indir+3),2);
  tkrec[1].sin_port=converti((indir+5),5);
  printf("La nuova connessione sara':\nlia%d %d -->lia%d %d\n",tkrec[1].sin_addr,tkrec[1].sin_port,ind,port);
  for(i=0;i<2;i++)
    printf("\n (%d) Elemento porta=(%d) indirizzo=  (%d)",i,tkrec[i].sin_addr,tkrec[i].sin_port); 
  return tkrec;
  }



int send_token3(HANDLE h, Token_format *tkout)		
{ Dimtoken_format dimout;
  int lung,w_bytes,n;

  if(crash==0) crash=1;      
		/*crash=0 token normale
                  crash=1 problemi con il mio precedente informo del guasto anche il resto del ring
		  crash=2 segnalazione esterna di un crash nel ring procedo al ripristino del ring*/
  dimout.stato=3;
  dimout.numelem=2;
  dimout.tkid=-1;
  lung=sizeof(dimout);
  printf("\n Spedisco la dimensione del %d token di segnalazione crash che vale 2 e stato %d",dimout.tkid,dimout.stato);
  for(w_bytes=0;w_bytes<lung;w_bytes+=n)
     n=send(h,((char*)&dimout)+w_bytes,lung-w_bytes,0);
  if(n!=lung) { printf("\nProblemi per spedire la dimensione del token -> Recovery");
                return(-1);
              }
  else
  {  
    lung=sizeof(*tkout)*2;
    printf("\nSpedisco il %d Token",dimout.tkid); 
    for(w_bytes=0;w_bytes<lung;w_bytes+=n)
        n=send(h,((char*)tkout)+w_bytes,lung-w_bytes,0); 
    if(n!=lung) { printf("\nProblemi per spedire il token -> Recovery");
                  return(-1);
                }
    else return(n);
  }
}


 int handletok(HANDLE h, HANDLE nexth)
{ Token_format *tkin,*tkout,tkapp[2];/*puntatori al token da ricevere e spedire*/
  int ret;
  char lia[5],indir[10];
  if((crash==1)&&(inrecovery==0)) 			
	{
	tkout=ripristina_ring(converti((myhost.name+3),2),mylen);
	inrecovery=1;
	return send_token3(nexth,tkout);
	}
  tkin=(Token_format *)malloc(sizeof(Token_format));
  tkout=(Token_format *)malloc(sizeof(Token_format));
  tkin=arraytoken;
  if((ret=recv_token(h,tkin))<=0) {printf("\nhandle tok ritorna %d",ret);
                                   return ret;} 
  if((statotoken==2)&&(precusc==0))     
		      {  
			  liaxx(arraytoken[0].sin_addr,lia);
			  sprintf(indir,"%s%d",lia,arraytoken[0].sin_port);
			  printf("\nVuole uscire il nodo%s\n",indir);
			  if(write(ipcex,indir,10)<0)
				{perror("Write");}
			  kill(0,SIGUSR1);	/*avverto l'altro figlio di aggiornare il ring*/
		      }
  if(crash==2) {
		printf("\nil token di emergenza contiene lia%d %d\n",arraytoken[0].sin_addr,arraytoken[0].sin_port);	
		tkout=ripristina_ring(arraytoken[0].sin_addr,arraytoken[0].sin_port);
		return send_token3(nexth,tkout);
		}
  else tkout=azione_token(tkin);  
  return send_token(nexth,tkout);  
}  

 int handledim(HANDLE h, HANDLE nexth)
{ Dimtoken_format req;
  static int ret;
  
  if((ret=recv_dimtoken(h,&req))<=0)
    {printf("\n  handle dim ritorna ret=%d",ret);
     if (ret==0) printf("\nconnessione chiusa");
     return ret;
    }
  if((statotoken==1)&&(azzera)&&(h==rcvtk)&&(sveglia!=2)) sveglia=1;
  switch(req.stato)
	{
  case 3: crash=2;
  case 0: if(sveglia==1) {write(ipcris,"ok",2);/*E' terminato l'inserimento=>sveglio l'altro figlio*/
		      printf("\nInserimento concluso\nAvverto l'altro figlio\n");
		      sveglia=0;
		      }
	}
  printf("\nHo ricevuto la dimensione del %d TOKEN e vale %u con stato %d",idtoken,req.numelem,req.stato);
  if (h!=rcvtk) dimtoken1=req.numelem;
  else  {dimtoken=req.numelem; 
	if(req.stato!=3)
	 statotoken=req.stato;
	else statotoken=0;
	}
   return (1); /*ok*/
} 

   /*req contiene ora info sulla dim del token che sta per arrivare. Tali info dovranno arrivare alla recv_token che lo leggera' si usa la var globale dimtoken*/
 

/*Servitore concorrente con connessione*/

int main(argc,argv)
int argc;
char **argv;
{ 
 HANDLE ricevi,listener,maxhp1,pidric,pidtok;
 int portar,portat,nextsd,nexthostport,creazione,tknew;
 int collegato_next=0,inizio=1,status,addrlen,ret,pidn;
 HANDLE rcvtk1,apporcv;
 fd_set read_hs,temp_hs;
 Token_format cord,secco;
 char nexthost[10],thishost[10];
 struct sockaddr_in precaddr_in;/*info sul nodo precedente del ring*/ 
 struct sockaddr_in peeraddr_in;


 printf("\nDigita il nome della macchina di esecuzione:");
 scanf("%s",thishost);

 printf("\nDigita il numero di porta sulla quale gestire le richieste:");
 scanf("%d",&portar);
 printf("\nDigita il numero di porta sulla quale gestire il token:"); 
 scanf("%d",&portat);
 mylen=portat;  
 printf("\nDigita il nome dell'host al quale inviare il token:"); 
 scanf("%s",nexthost);
 
 printf("\nDigita il numero di porta dell'host al quale inviare il token:"); 
 scanf("%d",&nexthostport);
 portoken=portat;
   
 memset((char*)&peeraddr_in,0,sizeof(struct sockaddr_in));
 memset((char*)&precaddr_in,0,sizeof(struct sockaddr_in));


if((pidn=fork())<0) exit(1);
if(pidn>0) exit(0);
else
{
setsid();
/*chdir("/"); */
umask(0);
/*  for(i=0;i<_NFILE;i++) close(i);*/
unlink("liaxx");
if(mknod("liaxx",S_IREAD|S_IWRITE|S_IFIFO,0000)<0)
{perror("mknod"); exit(0);}
ipcsd=open("liaxx",O_RDWR);
if(ipcsd<=0){perror("open");}
fcntl(ipcsd,F_SETFL,O_NONBLOCK);

 unlink("uscite");
if(mknod("uscite",S_IREAD|S_IWRITE|S_IFIFO,0000)<0)
{perror("mknod"); exit(0);}
ipcex=open("uscite",O_RDWR);
if(ipcex<=0){perror("open");}
fcntl(ipcex,F_SETFL,O_NONBLOCK);

 unlink("risposta");
if(mknod("risposta",S_IREAD|S_IWRITE|S_IFIFO,0000)<0)
{perror("mknod"); exit(0);}
ipcris=open("risposta",O_RDWR);
if(ipcris<=0){perror("open");}
fcntl(ipcris,F_SETFL,O_NONBLOCK);

 unlink("crash");
if(mknod("crash",S_IREAD|S_IWRITE|S_IFIFO,0000)<0)
{perror("mknod"); exit(0);}
ipccr=open("crash",O_RDWR);
if(ipccr<=0){perror("open");}
/*ipccr sara' messa non bloccante solo per il figlio che gestisce il token*/

 if ((pidric=fork())==0)   /*figlio che gestisce le richieste di inserimento nel ring*/
 { seccord.len=nexthostport;
   strcpy(seccord.name,nexthost);
   myhost.len=portat;
   strcpy(myhost.name,thishost);
 listener=create_server_endpoint(portar); 
  piniz=piniz1=precplav=plav=NULL;
  cord.sin_port=myhost.len;
  cord.sin_addr=converti((myhost.name+3),2);
  secco.sin_port=seccord.len;
  secco.sin_addr=converti((seccord.name+3),2);
  inizializza_ring(&cord,&secco); 
  stampa_ring();
 maxhp1=listener+1;
 FD_ZERO(&read_hs);
 FD_ZERO(&temp_hs);
 FD_SET(listener,&read_hs);
 FD_SET(listener,&temp_hs);
 temp_hs=read_hs;
 fcntl(ipccr,F_SETFL,O_NONBLOCK);
 sigset(SIGCHLD,SIG_IGN);
 sigset(SIGUSR1,gestsegn);
 for(;;)
    {
     HANDLE h,nread;
     char esito[2];
     /*Timeout nullo ed attesa infinita*/
     if(select(maxhp1,&temp_hs,0,0,(struct timeval*)0)<0)		
      if(errno==EINTR)
	{
	printf("\nSbloccata la select da un segnale");
        aggiorna_ring();       
	perror(" select,continuo");
	continue;
        }
      else perror("problemi con la select");	

 /*Verifica delle richieste presenti sulle connessioni solo se non ci sono altre richieste pendenti*/
     if(statotoken==0)	
     for(h=listener+1;h<maxhp1;h++)
     { if(FD_ISSET(h,&temp_hs))
         if(handle(h)==0)
         /*Chiusura della connessione da parte del cliente*/  
         {FD_CLR(h,&read_hs);
          close(h);}
	 else {
	      /*attendo l'esito dell'inserimento da parte dell'altro figlio*/
		
		while(nread=read(ipcris,esito,2)<2)
		{
		if(errno==EINTR)
			{
			printf("\nSbloccata la read da un segnale");
		        aggiorna_ring();    
			perror(" read,continuo");
		        }
		}
		printf("\nEsito inserimento %s\n",esito);
		/*controllo sul tipo di esito*/
	      }
     }/*For interno*/

     /*richieste di nuove connessioni */
     if(FD_ISSET(listener,&temp_hs)) 
    	/*Non mi interessa indirizzo di chi si collega a me */
 	   {    
                
 		h=accept(listener,0,0);
                printf("\nRicevuta una richiesta di inserimento di un nuovo nodo\n\n");
 		FD_SET(h,&read_hs);
 		if(maxhp1<=h) maxhp1=h+1;
           }
 	temp_hs=read_hs;

     }/*For*/ 
 }
 else
 
 if ((pidtok=fork())==0)     /*figlio che si occupa della gestione del token*/
 {collegato_next=0;inizio=1;
  sigset(SIGUSR1,SIG_IGN);

   seccord.len=nexthostport;
   strcpy(seccord.name,nexthost);
   myhost.len=portat;
   strcpy(myhost.name,thishost);
   ricevi=create_server_endpoint(myhost.len); /*crea la socket d'ascolto per il token*/
 if ((nextsd=create_nexthost_endpoint(seccord.len,nexthost))!=0) /*si collega con il nexthost*/
      { getsockname(nextsd,(struct sockaddr*)&peeraddr_in,&addrlen);
        printf("\nMi sono collegato con seccord sulla porta=%u",peeraddr_in.sin_port);
        collegato_next=1;
      }
  else exit(-1);
  

  maxhp1=ricevi+1;
  FD_ZERO(&read_hs);

  FD_ZERO(&temp_hs);
  FD_SET(ricevi,&read_hs);
  FD_SET(ricevi,&temp_hs);
  temp_hs=read_hs;
  rcvtk1=0; 
  sigset(SIGCLD,SIG_IGN);
   for(;;)
     { 
	select(maxhp1,&temp_hs,0,0,(struct timeval*)0);
       if ((ricevi+1)<maxhp1) /*condizione vera se e' stato effettuato il collegamento*/
       {  
           if(FD_ISSET(ricevi,&temp_hs)) 
           { /*significa che e' arrivata una richiesta di connessione di un nuovo nodo (forse non serve)
             printf("\n\n Arrivo di nuova richiesta");*/
           }

           if (FD_ISSET(rcvtk,&temp_hs)) 
           {  tknew=0;
	      crash=0;
	      if (statotoken!=1) tknew=1;
              sleep(2);
	      
              if ((ret=handledim(rcvtk,nextsd))<0) 
              { printf("per problemi sulla ricezione della dimensione del token-> recovery ret=%d",ret);
                close(rcvtk);		
	        FD_CLR(rcvtk,&read_hs);
                printf("\nTermina il figlio gestore del token");
                exit(0);
              }   
              if((ret==0)&&(statotoken!=2)&&(crash==0)) {
							FD_CLR(rcvtk,&read_hs);
							crash=1;
							}
        
              if (ret>=0)
              { printf("\n  gestione token con stato = %d\n",statotoken);
                if ((ret=handletok(rcvtk,nextsd))<=0) 
                { printf(" per problemi sulla ricezione del token recovery ret=%d\nchiudo %d",ret,rcvtk);
                  close(rcvtk);
                  printf("\nTermina il gestore del token");
                  exit(0);
                }
             }
           }
        }
           if (FD_ISSET(rcvtk1,&temp_hs)) 
           {  
              sleep(3);
              if ((ret=handledim(rcvtk1,nextsd))<0) 
              { printf("per problemi sulla ricezione della dimensione del token-> recovery\n");
                close(rcvtk1);
                printf("\nTermina il gestore della dimensione1 ");
                exit(0);
              }   
              if (ret>0)
              { printf("\ngestione del token proveniente dalla nuova connessione\n");
                sleep(3);
		if(crash>0) {if((ret=handletok(rcvtk1,nextsd))>0) crash=0;
			     inrecovery=0;
			     printf("\nrecovery concluso,nuova connessione %d",rcvtk1);
			     ok_token=1;} 
		else
                if ((ret=handle_new_tok(rcvtk1,nextsd))<=0) 
                { ok_token=0;
                  printf(" per problemi sulla ricezione del token recovery ret1=%d",ret);
                  close(rcvtk1);
                  printf("\nTermina il gestore del token1");
                  exit(0);
                }
                else ok_token=1;
	    }  
           }
          if ((tknew)&&(ok_token)) /*ho ricevuto token da due connessioni*/
          {  
              apporcv=rcvtk; 
	      FD_CLR(rcvtk,&read_hs);
    	      close(rcvtk); 
              rcvtk=rcvtk1;
	      rcvtk1=apporcv;     
              tknew=ok_token=0;
              printf("\nIl nuovo token e' valido quindi ho stabilito il nuovo collegamento\n");
	      sveglia=1;
           }
 
          if ((FD_ISSET(ricevi,&temp_hs)&& (ricevi+1==maxhp1))) 
            /*vera quando si effettua il collegamento
 	      Non mi interessa indirizzo di chi si collega a me */
 	    {       
                    rcvtk=accept(ricevi,0,0);
       		    FD_SET(rcvtk,&read_hs);
 		    if(maxhp1<=rcvtk) maxhp1=rcvtk+1;
 /* a questo punto il nodo ha effettuato a sua volta il 
 collegamento, a questo punto il ring e' chiuso*/
  	    }

    else if ((FD_ISSET(ricevi,&temp_hs)) && (ricevi+1<maxhp1))
 /*vera quando si effettua il secondo collegamento 
   Non mi interessa indirizzo di chi si collega a me */
 	{        
		rcvtk1=accept(ricevi,0,0);
 		FD_SET(rcvtk1,&read_hs);
 		if(maxhp1<=rcvtk1) maxhp1=rcvtk1 + 1;
                printf("\n\nRicevuta connessione da un nuovo nodo\n");
                getsockname(rcvtk1,(struct sockaddr*)&precaddr_in,&addrlen);
      	 	if ((precusc==1)||(crash==2))		
			       {
				if(rcvtk!=rcvtk1)
					{
/*c'e' il rischio che a rcvtk1 venga assegnato lo stesso valore di rcvtk (gia' chiuso sopra)*/
      		                          close(rcvtk);
		      	        	  FD_CLR(rcvtk,&read_hs);
					}
				printf("ho effettuato il cambio di connessione %d-->%d\n",rcvtk,rcvtk1);
				rcvtk=rcvtk1;
 				rcvtk1=0;				
			       }
       }

       if ((collegato_next)&&(inizio))  /*siamo al primo scambio dati*/
       { if((creazione=genera_token(nextsd))==0)
            {  printf("\nNon e' stato possibile generare il token");
               exit(-1);
            }  
         else 
         { printf("\nIl token e' stato generato e spedito"); 
                     inizio=0;
         }
       } 
      temp_hs=read_hs;
      FD_SET(ricevi,&read_hs);
      FD_SET(ricevi,&temp_hs);	
  }
}

else 
{ 
sigset(SIGUSR1,SIG_IGN);	
wait(&status);
wait(&status);
exit(0);}
 }
}/*Main*/ 

